package main

import (
	"fmt"

	"github.com/gordonklaus/portaudio"
	"github.com/naleek/gortty"
)

func main() {

	s := &gortty.ModemSettings{
		Baud:       45,
		StopBits:   2,
		DataBits:   5,
		SampleRate: 8000,
		OneFreq:    2125,
		ZeroFreq:   2295,
	}

	portaudio.Initialize()
	defer portaudio.Terminate()

	in := make([]int16, 64)
	stream, err := portaudio.OpenDefaultStream(1, 0, float64(s.SampleRate), len(in), in)
	if err != nil {
		panic(err)
	}
	defer stream.Close()
	charset := gortty.LoadCharset(&gortty.USTTY)
	//
	// encoderIn := make(chan rune)
	// modulatorIn := make(chan byte)

	demodulatorIn := make(chan int16)
	decoderIn := make(chan byte)
	decoderOut := make(chan rune)

	//done := make(chan struct{})

	//sig := make(chan [2]float64)
	// encoder := gortty.NewEncoder(encoderIn, modulatorIn, charset)
	// gortty.NewModulator(s, modulatorIn, demodulatorIn)
	gortty.NewDemodulator(s, demodulatorIn, decoderIn)
	gortty.NewDecoder(decoderIn, decoderOut, charset)

	go func() {
		for {
			r := <-decoderOut
			fmt.Printf("%c", r)
		}
	}()

	stream.Start()
	for {
		stream.Read()
		for i := range in {
			demodulatorIn <- in[i]
		}

	}
	//stream.Stop()

	// go func() {
	// 	encoder.EncodeString("hello world")
	// 	time.Sleep(2000 * time.Millisecond)
	// 	done <- struct{}{}
	// }()

}

// // NewOBL is fun
// func NewOBL(baud float64, callback Callback) *OBL {
//
// 	obl := new(OBL)
//
// 	obl.charset = USTTY.initialize()
//
// 	obl.callback = callback
//
// 	obl.mod.sinLutQ15 = make([]int16, 16384)
// 	for i := 0; i < 16384; i++ {
// 		obl.mod.sinLutQ15[i] = int16(32767 * math.Sin(2.0*math.Pi*float64(i)/float64(16384)))
// 	}
//
// 	/* regular reset */
// 	obl.autobaud.enabled = true
// 	obl.Reset(baud)
//
// 	go func() {
// 		portaudio.Initialize()
// 		defer portaudio.Terminate()
//
// 		x := make(chan int16, 300)
//
// 		stream, _ := portaudio.OpenDefaultStream(0, 1, float64(sampleRate), 0, func(out []int16) {
// 			for i := range out {
// 				out[i] = <-x
// 			}
// 		})
//
// 		stream.Start()
//
// 		for {
// 			s := <-obl.mod.output
// 			//go func() {
// 			obl.demod.input <- s
// 			x <- s
// 			//}()
// 			//	binary.Write(f, binary.LittleEndian, s)
// 		}
// 	}()
//
// 	go obl.Modulate()
// 	go obl.Demodulate()
//
// 	return obl
// }
