package main

import (
	"fmt"

	"github.com/gordonklaus/portaudio"
	"github.com/naleek/gortty"
)


type Frame struct {
	Seq		uint32
	Len		uint32
	Samples []byte
}

func main() {

	s := &gortty.ModemSettings{
		Baud:       45,
		StopBits:   2,
		DataBits:   5,
		SampleRate: 8000,
		OneFreq:    2125,
		ZeroFreq:   2295,
	}


	portaudio.Initialize()
	defer portaudio.Terminate()

	in := make([]int16, 64)
	
	stream, err := portaudio.OpenDefaultStream(1, 0, float64(s.SampleRate), len(in), in)
	if err != nil {
		panic(err)
	}
	defer stream.Close()
	
	RawDemodulatorIn := make(chan int16)
	RawDemodulatorOut := make(chan gortty.DCSignal)
	
	gortty.NewRawDemodulator(s, RawDemodulatorIn, RawDemodulatorOut)
	

	stream.Start()
	
	go func() {
		for v := range RawDemodulatorOut {
			fmt.Println(v)
		}
	}()
	
	for {
		stream.Read()
		for i := range in {
			RawDemodulatorIn <- in[i]
		}
	}
	
	

}
