package main

import (
	"github.com/gordonklaus/portaudio"
	"github.com/naleek/gortty"
	//"fmt"
)



func main() {

	s := &gortty.ModemSettings{
		Baud:       45,
		StopBits:   2,
		DataBits:   5,
		SampleRate: 8000,
		OneFreq:    1444,
		ZeroFreq:   1626,
	}
	
	s2 := &gortty.ModemSettings{
		Baud:       45,
		StopBits:   2,
		DataBits:   5,
		SampleRate: 8000,
		OneFreq:    2125,
		ZeroFreq:   2295,
	}

	portaudio.Initialize()
	defer portaudio.Terminate()

	in := make([]int16, 64)
	out := make([]int16, 64)

	stream, err := portaudio.OpenDefaultStream(1, 1, float64(s.SampleRate), len(in), in, out)
	if err != nil {
		panic(err)
	}
	defer stream.Close()
	
	RawDemodulatorIn := make(chan int16)
	RawDemodulatorOut := make(chan gortty.DCSignal)
	RawModulatorOut := make(chan int16)
	
	gortty.NewRawDemodulator(s, RawDemodulatorIn, RawDemodulatorOut)
	gortty.NewRawModulator(s2, RawDemodulatorOut, RawModulatorOut)

	stream.Start()
	
	go func() {
		l := 0
		for v := range RawModulatorOut {
			out[l] = v
			l++
			if l == 64 {
				l = 0
				stream.Write()
			}
		}
	}()
	
	for {
		stream.Read()
		for i := range in {
			RawDemodulatorIn <- in[i]
		}

	}

}

