package gortty_test

import (
	"testing"

	"github.com/naleek/gortty"
)

func TestEncoder(t *testing.T) {
	input := make(chan rune)
	output := make(chan byte)

	charset := gobaudot.LoadCharset(&gobaudot.USTTY)

	encoder := gobaudot.NewEncoder(input, output, charset)

	go func() {
		for range output {
		}
	}()

	encoder.SetAutoCRLF(false)

	encoder.EncodeString("hello\nworld!")
	encoder.EncodeString("hello                                                                                                                 ")
	encoder.EncodeString("hello!oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo")
	encoder.EncodeString("11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111")

	encoder.SetAutoCRLF(true)

	encoder.EncodeString("hello\rworld!")
	encoder.EncodeString("hello                                                                                                                 ")
	encoder.EncodeString("hello!oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo")
	encoder.EncodeString("11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111")

}
